
electronique_telecommande_002b_16f628_SetDirection:

;electronique_telecommande_002b_16f628.mpas,28 :: 		begin
;electronique_telecommande_002b_16f628.mpas,30 :: 		if bTx then
	MOVF       FARG_SetDirection_bTx+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_SetDirection2
;electronique_telecommande_002b_16f628.mpas,32 :: 		TRISA      := %11101111; // RA0..RA3 as inputs
	MOVLW      239
	MOVWF      TRISA+0
;electronique_telecommande_002b_16f628.mpas,33 :: 		TRISB      := %11111011; // RB0..RB7 as inputs, but RB2 as output
	MOVLW      251
	MOVWF      TRISB+0
;electronique_telecommande_002b_16f628.mpas,34 :: 		end
	GOTO       L_electronique_telecommande_002b_16f628_SetDirection3
;electronique_telecommande_002b_16f628.mpas,36 :: 		else begin
L_electronique_telecommande_002b_16f628_SetDirection2:
;electronique_telecommande_002b_16f628.mpas,37 :: 		TRISA      := %11100000; // RA0..RA3 as outputs
	MOVLW      224
	MOVWF      TRISA+0
;electronique_telecommande_002b_16f628.mpas,38 :: 		TRISB      := %00000010; // RB0..RB7 as outputs, but RB1 as input
	MOVLW      2
	MOVWF      TRISB+0
;electronique_telecommande_002b_16f628.mpas,39 :: 		end;
L_electronique_telecommande_002b_16f628_SetDirection3:
;electronique_telecommande_002b_16f628.mpas,40 :: 		PORTA :=   %00010000;  // clear portA, but let RA4 to high logic level (led off)
	MOVLW      16
	MOVWF      PORTA+0
;electronique_telecommande_002b_16f628.mpas,41 :: 		PORTB :=   0;  // clear portB
	CLRF       PORTB+0
;electronique_telecommande_002b_16f628.mpas,42 :: 		iRxData := 0;
	CLRF       _iRxData+0
;electronique_telecommande_002b_16f628.mpas,43 :: 		end;
	RETURN
; end of electronique_telecommande_002b_16f628_SetDirection

electronique_telecommande_002b_16f628_Init:

;electronique_telecommande_002b_16f628.mpas,46 :: 		begin
;electronique_telecommande_002b_16f628.mpas,47 :: 		CMCON := %00000111; // disable all comparators
	MOVLW      7
	MOVWF      CMCON+0
;electronique_telecommande_002b_16f628.mpas,48 :: 		VRCON := 0;
	CLRF       VRCON+0
;electronique_telecommande_002b_16f628.mpas,50 :: 		OPTION_REG.NOT_RBPU := 1; // disable pullup
	BSF        OPTION_REG+0, 7
;electronique_telecommande_002b_16f628.mpas,51 :: 		OPTION_REG.T0CS := 0;  // bit 5 TMR0 Clock Source Select bit:0=Internal Clock (CLKO) / 1=Transition on T0CKI pin
	BCF        OPTION_REG+0, 5
;electronique_telecommande_002b_16f628.mpas,52 :: 		OPTION_REG.T0SE := 0;  // bit 4 TMR0 Source Edge Select bit: 0=low/high / 1=high/low
	BCF        OPTION_REG+0, 4
;electronique_telecommande_002b_16f628.mpas,53 :: 		OPTION_REG.PSA  := 1;  // bit 3 Prescaler Assignment bit: 0=Prescaler is assigned to the Timer0
	BSF        OPTION_REG+0, 3
;electronique_telecommande_002b_16f628.mpas,54 :: 		OPTION_REG.PS2  := 0;  // bits 2-0  PS2:PS0: Prescaler Rate Select bits
	BCF        OPTION_REG+0, 2
;electronique_telecommande_002b_16f628.mpas,55 :: 		OPTION_REG.PS1  := 0;
	BCF        OPTION_REG+0, 1
;electronique_telecommande_002b_16f628.mpas,56 :: 		OPTION_REG.PS0  := 0;
	BCF        OPTION_REG+0, 0
;electronique_telecommande_002b_16f628.mpas,58 :: 		INTCON.GIE  := 1;  // enable global int
	BSF        INTCON+0, 7
;electronique_telecommande_002b_16f628.mpas,59 :: 		INTCON.PEIE := 1;  // enable peripheral int
	BSF        INTCON+0, 6
;electronique_telecommande_002b_16f628.mpas,60 :: 		INTCON.T0IE := 0;  // disable Timer0 int
	BCF        INTCON+0, 5
;electronique_telecommande_002b_16f628.mpas,61 :: 		INTCON.INTE := 0;  // disable RB0 int
	BCF        INTCON+0, 4
;electronique_telecommande_002b_16f628.mpas,62 :: 		INTCON.RBIE := 0;  // disable RB4..RB7 int
	BCF        INTCON+0, 3
;electronique_telecommande_002b_16f628.mpas,63 :: 		PIE1.RCIE   := 1;  // enable USART Rx int
	BSF        PIE1+0, 5
;electronique_telecommande_002b_16f628.mpas,64 :: 		PIR1.RCIF   := 0;  // reset USART Rx int flag
	BCF        PIR1+0, 5
;electronique_telecommande_002b_16f628.mpas,68 :: 		TRISA := %11101111; // RA0..RA7 as inputs
	MOVLW      239
	MOVWF      TRISA+0
;electronique_telecommande_002b_16f628.mpas,69 :: 		TRISB := %11111011; // RB0..RB7 as inputs, but RB2 (USART-TX) as output
	MOVLW      251
	MOVWF      TRISB+0
;electronique_telecommande_002b_16f628.mpas,71 :: 		PCON.OSCF := 1;  // Osc int - 4 MHz
	BSF        PCON+0, 3
;electronique_telecommande_002b_16f628.mpas,74 :: 		TXSTA.TXEN := 1;  // Tx enabled
	BSF        TXSTA+0, 5
;electronique_telecommande_002b_16f628.mpas,75 :: 		TXSTA.TX9  := 0;  // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_telecommande_002b_16f628.mpas,76 :: 		TXSTA.SYNC := 0;  // asynchronous mode
	BCF        TXSTA+0, 4
;electronique_telecommande_002b_16f628.mpas,77 :: 		RCSTA.SPEN := 1;  // Rx enabled;
	BSF        RCSTA+0, 7
;electronique_telecommande_002b_16f628.mpas,78 :: 		RCSTA.CREN := 1;  // enable continuous receive
	BSF        RCSTA+0, 4
;electronique_telecommande_002b_16f628.mpas,79 :: 		RCSTA.TX9  := 0;  // 8-bits transmission
	BCF        RCSTA+0, 6
;electronique_telecommande_002b_16f628.mpas,80 :: 		UART1_Init(9600); // change speed if needed
	MOVLW      25
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_telecommande_002b_16f628.mpas,82 :: 		PORTA :=   %00010000;  // clear portA, but let RA4 to high logic level (led off)
	MOVLW      16
	MOVWF      PORTA+0
;electronique_telecommande_002b_16f628.mpas,83 :: 		PORTB :=   0;  // clear portB
	CLRF       PORTB+0
;electronique_telecommande_002b_16f628.mpas,85 :: 		bSt0 := 0;
	CLRF       _bSt0+0
;electronique_telecommande_002b_16f628.mpas,86 :: 		bSt1 := 0;
	CLRF       _bSt1+0
;electronique_telecommande_002b_16f628.mpas,87 :: 		bSt2 := 0;
	CLRF       _bSt2+0
;electronique_telecommande_002b_16f628.mpas,88 :: 		bSt3 := 0;
	CLRF       _bSt3+0
;electronique_telecommande_002b_16f628.mpas,89 :: 		bSt4 := 0;
	CLRF       _bSt4+0
;electronique_telecommande_002b_16f628.mpas,90 :: 		bSt5 := 0;
	CLRF       _bSt5+0
;electronique_telecommande_002b_16f628.mpas,91 :: 		bSt6 := 0;
	CLRF       _bSt6+0
;electronique_telecommande_002b_16f628.mpas,92 :: 		bSt7 := 0;
	CLRF       _bSt7+0
;electronique_telecommande_002b_16f628.mpas,93 :: 		bSt8 := 0;
	CLRF       _bSt8+0
;electronique_telecommande_002b_16f628.mpas,94 :: 		bSt9 := 0;
	CLRF       _bSt9+0
;electronique_telecommande_002b_16f628.mpas,96 :: 		iRxData := 0;
	CLRF       _iRxData+0
;electronique_telecommande_002b_16f628.mpas,97 :: 		end;
	RETURN
; end of electronique_telecommande_002b_16f628_Init

electronique_telecommande_002b_16f628_Led_Flash:

;electronique_telecommande_002b_16f628.mpas,100 :: 		begin
;electronique_telecommande_002b_16f628.mpas,101 :: 		ClearBit(PORTA, 4);
	BCF        PORTA+0, 4
;electronique_telecommande_002b_16f628.mpas,102 :: 		Delay_ms(100);
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Led_Flash6:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Led_Flash6
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Led_Flash6
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,103 :: 		SetBit(PORTA, 4);
	BSF        PORTA+0, 4
;electronique_telecommande_002b_16f628.mpas,104 :: 		end;
	RETURN
; end of electronique_telecommande_002b_16f628_Led_Flash

electronique_telecommande_002b_16f628_Data_Send:

;electronique_telecommande_002b_16f628.mpas,111 :: 		begin
;electronique_telecommande_002b_16f628.mpas,113 :: 		TxData := idx;
	MOVF       FARG_Data_Send_idx+0, 0
	MOVWF      _TxData+0
;electronique_telecommande_002b_16f628.mpas,115 :: 		TxData.7 := bActive;
	BTFSC      FARG_Data_Send_bActive+0, 0
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send181
	BCF        _TxData+0, 7
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send182
L_electronique_telecommande_002b_16f628_Data_Send181:
	BSF        _TxData+0, 7
L_electronique_telecommande_002b_16f628_Data_Send182:
;electronique_telecommande_002b_16f628.mpas,116 :: 		TxData.6 := bActive;
	BTFSC      FARG_Data_Send_bActive+0, 0
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send183
	BCF        _TxData+0, 6
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send184
L_electronique_telecommande_002b_16f628_Data_Send183:
	BSF        _TxData+0, 6
L_electronique_telecommande_002b_16f628_Data_Send184:
;electronique_telecommande_002b_16f628.mpas,117 :: 		TxData.5 := bActive;
	BTFSC      FARG_Data_Send_bActive+0, 0
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send185
	BCF        _TxData+0, 5
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send186
L_electronique_telecommande_002b_16f628_Data_Send185:
	BSF        _TxData+0, 5
L_electronique_telecommande_002b_16f628_Data_Send186:
;electronique_telecommande_002b_16f628.mpas,118 :: 		TxData.4 := bActive;
	BTFSC      FARG_Data_Send_bActive+0, 0
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send187
	BCF        _TxData+0, 4
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send188
L_electronique_telecommande_002b_16f628_Data_Send187:
	BSF        _TxData+0, 4
L_electronique_telecommande_002b_16f628_Data_Send188:
;electronique_telecommande_002b_16f628.mpas,120 :: 		for iAttemps := 1 to 3 do
	MOVLW      1
	MOVWF      Data_Send_iAttemps+0
L_electronique_telecommande_002b_16f628_Data_Send9:
;electronique_telecommande_002b_16f628.mpas,122 :: 		bDataReceived := false;
	CLRF       _bDataReceived+0
;electronique_telecommande_002b_16f628.mpas,123 :: 		iRxData := 0;
	CLRF       _iRxData+0
;electronique_telecommande_002b_16f628.mpas,124 :: 		RxData[0] := $FE;      // value never used for command
	MOVLW      254
	MOVWF      _RxData+0
;electronique_telecommande_002b_16f628.mpas,125 :: 		RxData[1] := $FE;      // value never used for command
	MOVLW      254
	MOVWF      _RxData+1
;electronique_telecommande_002b_16f628.mpas,126 :: 		RxData[2] := $FE;      // value never used for command
	MOVLW      254
	MOVWF      _RxData+2
;electronique_telecommande_002b_16f628.mpas,127 :: 		UART1_Write(TxData);
	MOVF       _TxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002b_16f628.mpas,128 :: 		delay_ms(10);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send13:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send13
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send13
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,129 :: 		UART1_Write(TxData);
	MOVF       _TxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002b_16f628.mpas,130 :: 		delay_ms(10);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send14:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send14
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send14
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,131 :: 		UART1_Write(TxData);
	MOVF       _TxData+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002b_16f628.mpas,132 :: 		delay_ms(10);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send15:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send15
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send15
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,134 :: 		bDataReceivedOK := false;
	CLRF       _bDataReceivedOK+0
;electronique_telecommande_002b_16f628.mpas,135 :: 		iT := 0;
	CLRF       Data_Send_iT+0
;electronique_telecommande_002b_16f628.mpas,136 :: 		repeat
L_electronique_telecommande_002b_16f628_Data_Send16:
;electronique_telecommande_002b_16f628.mpas,137 :: 		inc(iT);
	INCF       Data_Send_iT+0, 1
;electronique_telecommande_002b_16f628.mpas,138 :: 		delay_us(1000);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      75
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send21:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send21
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send21
;electronique_telecommande_002b_16f628.mpas,139 :: 		bTimeOut := (iT >= 200);
	MOVLW      200
	SUBWF      Data_Send_iT+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 0
	MOVLW      0
	MOVWF      R2+0
;electronique_telecommande_002b_16f628.mpas,141 :: 		(RxData[0] = $FF) and (RxData[1] = TxData) and (RxData[2] = $FF));
	MOVF       _RxData+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _RxData+1, 0
	XORWF      _TxData+0, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	ANDWF      R1+0, 1
	MOVF       _RxData+2, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _bDataReceivedOK+0
;electronique_telecommande_002b_16f628.mpas,142 :: 		until (bTimeOut or bDataReceivedOK);
	MOVF       R2+0, 0
	IORWF      R0+0, 1
	BTFSS      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send19
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send16
L_electronique_telecommande_002b_16f628_Data_Send19:
;electronique_telecommande_002b_16f628.mpas,143 :: 		if bDataReceivedOK then
	MOVF       _bDataReceivedOK+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send23
;electronique_telecommande_002b_16f628.mpas,145 :: 		Led_Flash;
	CALL       electronique_telecommande_002b_16f628_Led_Flash+0
;electronique_telecommande_002b_16f628.mpas,146 :: 		break;
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send12
;electronique_telecommande_002b_16f628.mpas,147 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Send23:
;electronique_telecommande_002b_16f628.mpas,150 :: 		end;
	MOVF       Data_Send_iAttemps+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send12
	INCF       Data_Send_iAttemps+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send9
L_electronique_telecommande_002b_16f628_Data_Send12:
;electronique_telecommande_002b_16f628.mpas,151 :: 		end;
	RETURN
; end of electronique_telecommande_002b_16f628_Data_Send

electronique_telecommande_002b_16f628_Data_Send_Confirm:

;electronique_telecommande_002b_16f628.mpas,154 :: 		begin
;electronique_telecommande_002b_16f628.mpas,155 :: 		UART1_Write($FF);
	MOVLW      255
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002b_16f628.mpas,156 :: 		delay_ms(10);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send_Confirm26:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send_Confirm26
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send_Confirm26
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,157 :: 		UART1_Write(bRx);
	MOVF       FARG_Data_Send_Confirm_bRx+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002b_16f628.mpas,158 :: 		delay_ms(10);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send_Confirm27:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send_Confirm27
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send_Confirm27
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,159 :: 		UART1_Write($FF);
	MOVLW      255
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_telecommande_002b_16f628.mpas,160 :: 		delay_ms(10);
	MOVLW      13
	MOVWF      R12+0
	MOVLW      251
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Send_Confirm28:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send_Confirm28
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Send_Confirm28
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,161 :: 		end;
	RETURN
; end of electronique_telecommande_002b_16f628_Data_Send_Confirm

electronique_telecommande_002b_16f628_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_telecommande_002b_16f628.mpas,164 :: 		begin
;electronique_telecommande_002b_16f628.mpas,165 :: 		if TestBit(PIR1, RCIF) then
	CLRF       R0+0
	BTFSS      PIR1+0, 5
	GOTO       L_electronique_telecommande_002b_16f628_Interrupt33
	MOVLW      1
	MOVWF      R0+0
L_electronique_telecommande_002b_16f628_Interrupt33:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Interrupt31
;electronique_telecommande_002b_16f628.mpas,168 :: 		RxData[iRxData] := RCREG;
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      FSR
	MOVF       RCREG+0, 0
	MOVWF      INDF+0
;electronique_telecommande_002b_16f628.mpas,170 :: 		if iRxData < 2 then
	MOVLW      2
	SUBWF      _iRxData+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_electronique_telecommande_002b_16f628_Interrupt35
;electronique_telecommande_002b_16f628.mpas,171 :: 		inc(iRxData)
	INCF       _iRxData+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Interrupt36
;electronique_telecommande_002b_16f628.mpas,172 :: 		else
L_electronique_telecommande_002b_16f628_Interrupt35:
;electronique_telecommande_002b_16f628.mpas,173 :: 		iRxData := 0;
	CLRF       _iRxData+0
L_electronique_telecommande_002b_16f628_Interrupt36:
;electronique_telecommande_002b_16f628.mpas,174 :: 		bDataReceived := true;
	MOVLW      255
	MOVWF      _bDataReceived+0
;electronique_telecommande_002b_16f628.mpas,176 :: 		if TestBit(RCSTA, OERR) then
	CLRF       R0+0
	BTFSS      RCSTA+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Interrupt40
	MOVLW      1
	MOVWF      R0+0
L_electronique_telecommande_002b_16f628_Interrupt40:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Interrupt38
;electronique_telecommande_002b_16f628.mpas,178 :: 		ClearBit(RCSTA, CREN);
	BCF        RCSTA+0, 4
;electronique_telecommande_002b_16f628.mpas,179 :: 		SetBit(RCSTA, CREN);
	BSF        RCSTA+0, 4
;electronique_telecommande_002b_16f628.mpas,180 :: 		end;
L_electronique_telecommande_002b_16f628_Interrupt38:
;electronique_telecommande_002b_16f628.mpas,182 :: 		end;
L_electronique_telecommande_002b_16f628_Interrupt31:
;electronique_telecommande_002b_16f628.mpas,183 :: 		end;
L_electronique_telecommande_002b_16f628_Interrupt189:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of electronique_telecommande_002b_16f628_Interrupt

electronique_telecommande_002b_16f628_Data_Read:

;electronique_telecommande_002b_16f628.mpas,186 :: 		begin
;electronique_telecommande_002b_16f628.mpas,188 :: 		if (PORTA.0 <> bSt0) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 0
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read43
;electronique_telecommande_002b_16f628.mpas,190 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read45:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read45
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read45
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,191 :: 		if (PORTA.0 <> bSt0) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 0
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read47
;electronique_telecommande_002b_16f628.mpas,193 :: 		Data_Send(0, PORTA.0);
	CLRF       FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTA+0, 0
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,194 :: 		bSt0 := PORTA.0;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTA+0, 0
	MOVLW      1
	MOVWF      _bSt0+0
;electronique_telecommande_002b_16f628.mpas,195 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read47:
;electronique_telecommande_002b_16f628.mpas,196 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read43:
;electronique_telecommande_002b_16f628.mpas,198 :: 		if (PORTA.1 <> bSt1) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 1
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt1+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read50
;electronique_telecommande_002b_16f628.mpas,200 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read52:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read52
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read52
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,201 :: 		if (PORTA.1 <> bSt1) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 1
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt1+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read54
;electronique_telecommande_002b_16f628.mpas,203 :: 		Data_Send(1, PORTA.1);
	MOVLW      1
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTA+0, 1
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,204 :: 		bSt1 := PORTA.1;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTA+0, 1
	MOVLW      1
	MOVWF      _bSt1+0
;electronique_telecommande_002b_16f628.mpas,205 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read54:
;electronique_telecommande_002b_16f628.mpas,206 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read50:
;electronique_telecommande_002b_16f628.mpas,208 :: 		if (PORTA.2 <> bSt2) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 2
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt2+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read57
;electronique_telecommande_002b_16f628.mpas,210 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read59:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read59
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read59
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,211 :: 		if (PORTA.2 <> bSt2) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 2
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt2+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read61
;electronique_telecommande_002b_16f628.mpas,213 :: 		Data_Send(2, PORTA.2);
	MOVLW      2
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTA+0, 2
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,214 :: 		bSt2 := PORTA.2;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTA+0, 2
	MOVLW      1
	MOVWF      _bSt2+0
;electronique_telecommande_002b_16f628.mpas,215 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read61:
;electronique_telecommande_002b_16f628.mpas,216 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read57:
;electronique_telecommande_002b_16f628.mpas,218 :: 		if (PORTA.3 <> bSt3) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 3
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt3+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read64
;electronique_telecommande_002b_16f628.mpas,220 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read66:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read66
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read66
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,221 :: 		if (PORTA.3 <> bSt3) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTA+0, 3
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt3+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read68
;electronique_telecommande_002b_16f628.mpas,223 :: 		Data_Send(3, PORTA.3);
	MOVLW      3
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTA+0, 3
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,224 :: 		bSt3 := PORTA.3;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTA+0, 3
	MOVLW      1
	MOVWF      _bSt3+0
;electronique_telecommande_002b_16f628.mpas,225 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read68:
;electronique_telecommande_002b_16f628.mpas,226 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read64:
;electronique_telecommande_002b_16f628.mpas,228 :: 		if (PORTB.0 <> bSt4) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 0
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt4+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read71
;electronique_telecommande_002b_16f628.mpas,230 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read73:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read73
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read73
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,231 :: 		if (PORTB.0 <> bSt4) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 0
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt4+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read75
;electronique_telecommande_002b_16f628.mpas,233 :: 		Data_Send(4, PORTB.0);
	MOVLW      4
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTB+0, 0
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,234 :: 		bSt4 := PORTB.0;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTB+0, 0
	MOVLW      1
	MOVWF      _bSt4+0
;electronique_telecommande_002b_16f628.mpas,235 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read75:
;electronique_telecommande_002b_16f628.mpas,236 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read71:
;electronique_telecommande_002b_16f628.mpas,238 :: 		if (PORTB.3 <> bSt5) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 3
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt5+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read78
;electronique_telecommande_002b_16f628.mpas,240 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read80:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read80
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read80
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,241 :: 		if (PORTB.3 <> bSt5) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 3
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt5+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read82
;electronique_telecommande_002b_16f628.mpas,243 :: 		Data_Send(5, PORTB.3);
	MOVLW      5
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTB+0, 3
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,244 :: 		bSt5 := PORTB.3;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTB+0, 3
	MOVLW      1
	MOVWF      _bSt5+0
;electronique_telecommande_002b_16f628.mpas,245 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read82:
;electronique_telecommande_002b_16f628.mpas,246 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read78:
;electronique_telecommande_002b_16f628.mpas,248 :: 		if (PORTB.4 <> bSt6) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 4
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt6+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read85
;electronique_telecommande_002b_16f628.mpas,250 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read87:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read87
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read87
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,251 :: 		if (PORTB.4 <> bSt6) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 4
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt6+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read89
;electronique_telecommande_002b_16f628.mpas,253 :: 		Data_Send(6, PORTB.4);
	MOVLW      6
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTB+0, 4
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,254 :: 		bSt6 := PORTB.4;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTB+0, 4
	MOVLW      1
	MOVWF      _bSt6+0
;electronique_telecommande_002b_16f628.mpas,255 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read89:
;electronique_telecommande_002b_16f628.mpas,256 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read85:
;electronique_telecommande_002b_16f628.mpas,258 :: 		if (PORTB.5 <> bSt7) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 5
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt7+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read92
;electronique_telecommande_002b_16f628.mpas,260 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read94:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read94
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read94
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,261 :: 		if (PORTB.5 <> bSt7) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 5
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt7+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read96
;electronique_telecommande_002b_16f628.mpas,263 :: 		Data_Send(7, PORTB.5);
	MOVLW      7
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTB+0, 5
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,264 :: 		bSt7 := PORTB.5;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTB+0, 5
	MOVLW      1
	MOVWF      _bSt7+0
;electronique_telecommande_002b_16f628.mpas,265 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read96:
;electronique_telecommande_002b_16f628.mpas,266 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read92:
;electronique_telecommande_002b_16f628.mpas,268 :: 		if (PORTB.6 <> bSt8) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 6
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt8+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read99
;electronique_telecommande_002b_16f628.mpas,270 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read101:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read101
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read101
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,271 :: 		if (PORTB.6 <> bSt8) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 6
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt8+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read103
;electronique_telecommande_002b_16f628.mpas,273 :: 		Data_Send(8, PORTB.6);
	MOVLW      8
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTB+0, 6
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,274 :: 		bSt8 := PORTB.6;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTB+0, 6
	MOVLW      1
	MOVWF      _bSt8+0
;electronique_telecommande_002b_16f628.mpas,275 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read103:
;electronique_telecommande_002b_16f628.mpas,276 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read99:
;electronique_telecommande_002b_16f628.mpas,278 :: 		if (PORTB.7 <> bSt9) then   // compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 7
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt9+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read106
;electronique_telecommande_002b_16f628.mpas,280 :: 		delay_ms(100);            // soft debouncing
	MOVLW      130
	MOVWF      R12+0
	MOVLW      221
	MOVWF      R13+0
L_electronique_telecommande_002b_16f628_Data_Read108:
	DECFSZ     R13+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read108
	DECFSZ     R12+0, 1
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read108
	NOP
	NOP
;electronique_telecommande_002b_16f628.mpas,281 :: 		if (PORTB.7 <> bSt9) then // re-compare actual values with previous values
	CLRF       R1+0
	BTFSC      PORTB+0, 7
	INCF       R1+0, 1
	MOVF       R1+0, 0
	XORWF      _bSt9+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_electronique_telecommande_002b_16f628_Data_Read110
;electronique_telecommande_002b_16f628.mpas,283 :: 		Data_Send(9, PORTB.7);
	MOVLW      9
	MOVWF      FARG_Data_Send_idx+0
	MOVLW      0
	BTFSC      PORTB+0, 7
	MOVLW      1
	MOVWF      FARG_Data_Send_bActive+0
	CALL       electronique_telecommande_002b_16f628_Data_Send+0
;electronique_telecommande_002b_16f628.mpas,284 :: 		bSt9 := PORTB.7;        // store actual value for next compare
	MOVLW      0
	BTFSC      PORTB+0, 7
	MOVLW      1
	MOVWF      _bSt9+0
;electronique_telecommande_002b_16f628.mpas,285 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read110:
;electronique_telecommande_002b_16f628.mpas,286 :: 		end;
L_electronique_telecommande_002b_16f628_Data_Read106:
;electronique_telecommande_002b_16f628.mpas,292 :: 		end;
	RETURN
; end of electronique_telecommande_002b_16f628_Data_Read

_main:

;electronique_telecommande_002b_16f628.mpas,294 :: 		begin
;electronique_telecommande_002b_16f628.mpas,295 :: 		Init;
	CALL       electronique_telecommande_002b_16f628_Init+0
;electronique_telecommande_002b_16f628.mpas,296 :: 		bDirTx := TestBit(PORTA, 5);  // RA7 in TC 002 version
	CLRF       R0+0
	BTFSS      PORTA+0, 5
	GOTO       L__main113
	MOVLW      1
	MOVWF      R0+0
L__main113:
	MOVF       R0+0, 0
	MOVWF      _bDirTx+0
;electronique_telecommande_002b_16f628.mpas,297 :: 		SetDirection(bDirTx); // set mode as Tx or Rx, as set by RA5 state
	MOVF       R0+0, 0
	MOVWF      FARG_SetDirection_bTx+0
	CALL       electronique_telecommande_002b_16f628_SetDirection+0
;electronique_telecommande_002b_16f628.mpas,298 :: 		bDirTxOld := bDirTx;
	MOVF       _bDirTx+0, 0
	MOVWF      _bDirTxOld+0
;electronique_telecommande_002b_16f628.mpas,300 :: 		while true do
L__main115:
;electronique_telecommande_002b_16f628.mpas,304 :: 		bDirTx := TestBit(PORTA, 5); // RA7 in TC 002 version
	CLRF       R1+0
	BTFSS      PORTA+0, 5
	GOTO       L__main119
	MOVLW      1
	MOVWF      R1+0
L__main119:
	MOVF       R1+0, 0
	MOVWF      _bDirTx+0
;electronique_telecommande_002b_16f628.mpas,305 :: 		if bDirTx <> bDirTxOld then
	MOVF       R1+0, 0
	XORWF      _bDirTxOld+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main121
;electronique_telecommande_002b_16f628.mpas,307 :: 		SetDirection(bDirTx); // set mode as Tx or Rx, as set by RA5 state
	MOVF       _bDirTx+0, 0
	MOVWF      FARG_SetDirection_bTx+0
	CALL       electronique_telecommande_002b_16f628_SetDirection+0
;electronique_telecommande_002b_16f628.mpas,308 :: 		bDirTxOld := bDirTx;
	MOVF       _bDirTx+0, 0
	MOVWF      _bDirTxOld+0
;electronique_telecommande_002b_16f628.mpas,309 :: 		end;
L__main121:
;electronique_telecommande_002b_16f628.mpas,314 :: 		if bDirTx then
	MOVF       _bDirTx+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main124
;electronique_telecommande_002b_16f628.mpas,316 :: 		Data_Read;
	CALL       electronique_telecommande_002b_16f628_Data_Read+0
;electronique_telecommande_002b_16f628.mpas,317 :: 		end
	GOTO       L__main125
;electronique_telecommande_002b_16f628.mpas,320 :: 		else begin
L__main124:
;electronique_telecommande_002b_16f628.mpas,321 :: 		if bDataReceived then  // int occured by receiving data on Rx pin
	MOVF       _bDataReceived+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main127
;electronique_telecommande_002b_16f628.mpas,324 :: 		bRxDataOK := ((RxData[0] = RxData[1]) and (RxData[0] = RxData[2]));
	MOVF       _RxData+0, 0
	XORWF      _RxData+1, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       _RxData+0, 0
	XORWF      _RxData+2, 0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	MOVF       R0+0, 0
	MOVWF      _bRxDataOK+0
;electronique_telecommande_002b_16f628.mpas,325 :: 		if bRxDataOK then
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main130
;electronique_telecommande_002b_16f628.mpas,327 :: 		RxData_Index := 0;
	CLRF       _RxData_Index+0
;electronique_telecommande_002b_16f628.mpas,328 :: 		if TestBit(RxData[iRxData], 0) then RxData_Index := RxData_Index + 1;
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 0
	GOTO       L__main135
	MOVLW      1
	MOVWF      R0+0
L__main135:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main133
	INCF       _RxData_Index+0, 1
L__main133:
;electronique_telecommande_002b_16f628.mpas,329 :: 		if TestBit(RxData[iRxData], 1) then RxData_Index := RxData_Index + 2;
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 1
	GOTO       L__main139
	MOVLW      1
	MOVWF      R0+0
L__main139:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main137
	MOVLW      2
	ADDWF      _RxData_Index+0, 1
L__main137:
;electronique_telecommande_002b_16f628.mpas,330 :: 		if TestBit(RxData[iRxData], 2) then RxData_Index := RxData_Index + 4;
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 2
	GOTO       L__main143
	MOVLW      1
	MOVWF      R0+0
L__main143:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main141
	MOVLW      4
	ADDWF      _RxData_Index+0, 1
L__main141:
;electronique_telecommande_002b_16f628.mpas,331 :: 		if TestBit(RxData[iRxData], 3) then RxData_Index := RxData_Index + 8;
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 3
	GOTO       L__main147
	MOVLW      1
	MOVWF      R0+0
L__main147:
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main145
	MOVLW      8
	ADDWF      _RxData_Index+0, 1
L__main145:
;electronique_telecommande_002b_16f628.mpas,332 :: 		bActive := ((RxData[iRxData].6 = 1) and (RxData[iRxData].7 = 1));
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      R0+0
	CLRF       R2+0
	MOVF       R0+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 6
	GOTO       L__main148
	MOVLW      255
	MOVWF      R2+0
L__main148:
	MOVF       _iRxData+0, 0
	ADDLW      _RxData+0
	MOVWF      R1+0
	CLRF       R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	BTFSS      INDF+0, 7
	GOTO       L__main149
	MOVLW      255
	MOVWF      R0+0
L__main149:
	MOVF       R0+0, 0
	ANDWF      R2+0, 0
	MOVWF      _bActive+0
;electronique_telecommande_002b_16f628.mpas,334 :: 		0 : PORTA.0 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main153
	BTFSC      _bActive+0, 0
	GOTO       L__main190
	BCF        PORTA+0, 0
	GOTO       L__main191
L__main190:
	BSF        PORTA+0, 0
L__main191:
	GOTO       L__main150
L__main153:
;electronique_telecommande_002b_16f628.mpas,335 :: 		1 : PORTA.1 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__main156
	BTFSC      _bActive+0, 0
	GOTO       L__main192
	BCF        PORTA+0, 1
	GOTO       L__main193
L__main192:
	BSF        PORTA+0, 1
L__main193:
	GOTO       L__main150
L__main156:
;electronique_telecommande_002b_16f628.mpas,336 :: 		2 : PORTA.2 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__main159
	BTFSC      _bActive+0, 0
	GOTO       L__main194
	BCF        PORTA+0, 2
	GOTO       L__main195
L__main194:
	BSF        PORTA+0, 2
L__main195:
	GOTO       L__main150
L__main159:
;electronique_telecommande_002b_16f628.mpas,337 :: 		3 : PORTA.3 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__main162
	BTFSC      _bActive+0, 0
	GOTO       L__main196
	BCF        PORTA+0, 3
	GOTO       L__main197
L__main196:
	BSF        PORTA+0, 3
L__main197:
	GOTO       L__main150
L__main162:
;electronique_telecommande_002b_16f628.mpas,338 :: 		4 : PORTB.0 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      4
	BTFSS      STATUS+0, 2
	GOTO       L__main165
	BTFSC      _bActive+0, 0
	GOTO       L__main198
	BCF        PORTB+0, 0
	GOTO       L__main199
L__main198:
	BSF        PORTB+0, 0
L__main199:
	GOTO       L__main150
L__main165:
;electronique_telecommande_002b_16f628.mpas,339 :: 		5 : PORTB.3 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      5
	BTFSS      STATUS+0, 2
	GOTO       L__main168
	BTFSC      _bActive+0, 0
	GOTO       L__main200
	BCF        PORTB+0, 3
	GOTO       L__main201
L__main200:
	BSF        PORTB+0, 3
L__main201:
	GOTO       L__main150
L__main168:
;electronique_telecommande_002b_16f628.mpas,340 :: 		6 : PORTB.4 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      6
	BTFSS      STATUS+0, 2
	GOTO       L__main171
	BTFSC      _bActive+0, 0
	GOTO       L__main202
	BCF        PORTB+0, 4
	GOTO       L__main203
L__main202:
	BSF        PORTB+0, 4
L__main203:
	GOTO       L__main150
L__main171:
;electronique_telecommande_002b_16f628.mpas,341 :: 		7 : PORTB.5 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      7
	BTFSS      STATUS+0, 2
	GOTO       L__main174
	BTFSC      _bActive+0, 0
	GOTO       L__main204
	BCF        PORTB+0, 5
	GOTO       L__main205
L__main204:
	BSF        PORTB+0, 5
L__main205:
	GOTO       L__main150
L__main174:
;electronique_telecommande_002b_16f628.mpas,342 :: 		8 : PORTB.6 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L__main177
	BTFSC      _bActive+0, 0
	GOTO       L__main206
	BCF        PORTB+0, 6
	GOTO       L__main207
L__main206:
	BSF        PORTB+0, 6
L__main207:
	GOTO       L__main150
L__main177:
;electronique_telecommande_002b_16f628.mpas,343 :: 		9 : PORTB.7 := bActive;
	MOVF       _RxData_Index+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L__main180
	BTFSC      _bActive+0, 0
	GOTO       L__main208
	BCF        PORTB+0, 7
	GOTO       L__main209
L__main208:
	BSF        PORTB+0, 7
L__main209:
	GOTO       L__main150
L__main180:
L__main150:
;electronique_telecommande_002b_16f628.mpas,345 :: 		Data_Send_Confirm(RxData[0]);
	MOVF       _RxData+0, 0
	MOVWF      FARG_Data_Send_Confirm_bRx+0
	CALL       electronique_telecommande_002b_16f628_Data_Send_Confirm+0
;electronique_telecommande_002b_16f628.mpas,346 :: 		Led_Flash;
	CALL       electronique_telecommande_002b_16f628_Led_Flash+0
;electronique_telecommande_002b_16f628.mpas,347 :: 		end;
L__main130:
;electronique_telecommande_002b_16f628.mpas,348 :: 		bDataReceived := false;   // reset int flag to allow detection of next byte
	CLRF       _bDataReceived+0
;electronique_telecommande_002b_16f628.mpas,349 :: 		end;
L__main127:
;electronique_telecommande_002b_16f628.mpas,350 :: 		end;
L__main125:
;electronique_telecommande_002b_16f628.mpas,351 :: 		end;
	GOTO       L__main115
;electronique_telecommande_002b_16f628.mpas,353 :: 		end.
	GOTO       $+0
; end of _main
